﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RFID_Demo
{
    public partial class frmLF : Form
    {
        frmMain fc;
        public frmLF(frmMain fc)
        {
            InitializeComponent();
            this.fc = fc;
        }

        public bool IsKeyAction = false;
        public bool IsFirst;


        public void SetActiveButton()
        {
            if ((GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString()) == 0) | (GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString()) == 2) | (GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString()) == 8))
            {
                cbReadWriteBox.Enabled = false;
                NumBlock.Enabled = false;
                btReadWriteData.Enabled = false;
                txtData.Enabled = false;
            }
            else
            {
                cbReadWriteBox.Enabled = true;
                NumBlock.Enabled = true;
                btReadWriteData.Enabled = true;
                txtData.Enabled = true;
            }
            if (GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString()) == 4)
            {
                txtData.MaxLength = 16;
                // HDX-Transponder müssen zum Schreiben 16 Zeichen haben
            }
            else
            {
                txtData.MaxLength = 8;
            }
            if (GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString()) == 7)
            {
                SpecialItem.Enabled = true;
                TitanPassItem.Enabled = true;
                Hitag2Item.Enabled = false;
            }
            else if (GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString()) == 5)
            {
                SpecialItem.Enabled = true;
                TitanPassItem.Enabled = false;
                Hitag2Item.Enabled = true;
            }
            else
            {
                SpecialItem.Enabled = false;
                TitanPassItem.Enabled = false;
                Hitag2Item.Enabled = false;
            }
        }

        private void btGetVersion_Click(Object sender, EventArgs e)
        {
            string Version = "";
            Version = fc.MyBTLF.GetVersion();
            lbReaderInfo.Text = Version;
            InfoAdd(Version);
        }

        public int GetTagTypeIndex(int value)
        {
            int functionReturnValue = 0;
            int i = 0;
            string tmp = "";
            for (i = 0; i <= TagView.Items.Count - 1; i++)
            {
                tmp = TagView.Items[i].ToString();
                tmp = tmp.Substring(4, 1);
                if (value == Convert.ToInt32(tmp))
                {
                    functionReturnValue = i;
                    return functionReturnValue;
                }
            }
            return functionReturnValue;
        }

        private int GetTagTypeFormItem(string value)
        {
            //Typ 0 - EM 41xx (UNIQUE) - RO
            string tmp = string.Empty;
            tmp = value.Substring(4, 1);
            return Convert.ToInt32(tmp);
        }


        private void TagView_SelectedIndexChanged(Object sender, EventArgs e)
        {
            string MyText = string.Empty;
            int MyResult = 0;
            int MyItem = 0;
            MyText = "";
            MyItem = TagView.SelectedIndex;
            //fc.TagType = TagView.SelectedIndex ' wurde umgebaut, nur Transponder die in der Firmenversion sind, soll man sehen
            fc.TagType = GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString());
            fc.TagName = TagView.Items[TagView.SelectedIndex].ToString();
            btReadTransponder.Text = "Read Transponder (" + fc.TagType.ToString() + ")";
            SetActiveButton();
            return;
            if (IsFirst)
            {
                //fc.TagType = TagView.SelectedIndex
                fc.TagType = GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString());
                fc.TagName = TagView.Items[TagView.SelectedIndex].ToString();
                btReadTransponder.Text = "Read Transponder (" + fc.TagType.ToString() + ")";
                SetActiveButton();
                IsFirst = true;
                return;
            }
            frmPass MyPassDlg = new frmPass();
            try
            {
                MyPassDlg.txtPassword.Focus();
                MyPassDlg.ShowDialog();
                MyResult = MyPassDlg.MyResult;
                if (MyResult == 1)
                {
                    MyText = MyPassDlg.txtPassword.Text;
                }
            }
            finally
            {
                if ((MyPassDlg != null))
                {
                    MyPassDlg.Dispose();
                    MyPassDlg = null;
                }
            }
            if (MyResult == 1)
            {
                if (MyText == "0147")
                {
                    MessageBox.Show("Change Tag-Typ successful");
                    //fc.TagType = TagView.SelectedIndex
                    fc.TagType = GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString());
                    fc.TagName = TagView.Items[TagView.SelectedIndex].ToString() ;
                    btReadTransponder.Text = "Read Transponder (" + fc.TagType.ToString() + ")";
                    SetActiveButton();
                    return;
                }
            }
            MessageBox.Show("No Change Tag-Typ");
            IsFirst = true;
            //TagView.SelectedIndex = fc.TagType
            TagView.SelectedIndex = MyItem;
            IsFirst = false;
        }

        public void ReadTransponder()
        {
            IsKeyAction = true;
            btReadTransponder_Click(null, null);
            IsKeyAction = false;
        }


        private void btReadTransponder_Click(Object sender, EventArgs e)
        {
            //fc.TagType = TagView.SelectedIndex
            fc.TagType = GetTagTypeFormItem(TagView.Items[TagView.SelectedIndex].ToString());
            try
            {
                btReadTransponder.Enabled = false;
                btReadWriteData.Enabled = false;
                btGetVersion.Enabled = false;
                if (cbConti.Checked)
                {
                    InfoAdd("Start Continues Read");
                }
                do
                {
                    //InfoAdd("Search Transponder...")
                    System.Windows.Forms.Application.DoEvents();
                    //fc.TagType = GetTagTypeFormItem(TagView.Items(TagView.SelectedIndex))
                    if (fc.TagType == 7)
                    {
                        fc.MyBTLF.TitanPassword = "00000000";
                    }
                    fc.RFIDData = fc.MyBTLF.SelectTag(fc.TagType);

                    if (fc.MyBTLF.IsTagSelect)
                    {
                        InfoAdd("TAG-Nr. :" + fc.RFIDData);
                        fc.PlaySound();
                        fc.SendUIDNr(fc.RFIDData.ToString());
                    }
                    else
                    {
                        if ((fc.RFIDData.IndexOf("- 1") >= 0) | (fc.RFIDData.IndexOf("- 2") >= 0) | (fc.RFIDData.IndexOf("- 3") >= 0) |(fc.RFIDData.IndexOf("- 4") >= 0) |(fc.RFIDData.IndexOf("- 5") >= 0)|(fc.RFIDData.IndexOf("- 6") >= 0))      
                        {
                            InfoAdd("[" + fc.RFIDData + " ] No Transponder selected");
                        }
                        else if (fc.RFIDData == "Error: 54")
                        {
                            InfoAdd("[54] Not available in this firmware");
                        }
                        else if (fc.RFIDData == "- 99")
                        {
                            InfoAdd("[- 99] Reader-Error");
                        }
                    }


                } while (cbConti.Checked);
            }
            finally
            {
                btReadTransponder.Enabled = true;
                btReadWriteData.Enabled = true;
                btGetVersion.Enabled = true;
                if ((fc.TagType == 0) | (fc.TagType == 2) | (fc.TagType == 8))
                {
                    btReadWriteData.Enabled = false;
                }
            }
        }

        public void InfoAdd(string Value)
        {
            try
            {
                if (string.IsNullOrEmpty(Value))
                {
                    return;
                }
                //Dim itmp As New Windows.Forms.ListViewItem(Value)
                ListBox1.Items.Add(Value);
                ListBox1.SelectedIndex = ListBox1.Items.Count - 1;
                if (ListBox1.Items.Count >= 1000)
                {
                    ListBox1.Items.Clear();
                }
            }
            catch (Exception ex)
            {
                //            WriteErrorFile(ex.Message)
            }

        }

        //Private Sub MyTLM30_TLMData(ByVal Sender As Object, ByVal Direction As String, ByVal Data As String) Handles MyTLM30.TLMData
        //   If cbEvent.Checked Then
        //      InfoAdd(Direction & " " & Data)
        // End If
        //End Sub

        private void btReadWriteData_Click(Object sender, EventArgs e)
        {
            ReadTransponder();
            if (!fc.MyBTLF.IsTagSelect)
            {
                return;
            }
            try
            {
                cbReadWriteBox.Enabled = false;
                if (cbReadWriteBox.SelectedIndex == 0)
                {
                    txtData.Text = "";
                    fc.RFIDData = fc.MyBTLF.ReadTagData(fc.TagType, NumBlock.Value.ToString());
                    if ((fc.RFIDData == "- 1"))
                    {
                        InfoAdd("Read Error");
                    }
                    if ((fc.RFIDData == "- 2"))
                    {
                        InfoAdd("Read Error");
                    }
                    if (fc.RFIDData.Length >= 8)
                    {
                        InfoAdd("Tag-Data: " + fc.RFIDData);
                        txtData.Text = fc.RFIDData;
                    }
                }
                if (cbReadWriteBox.SelectedIndex == 1)
                {
                    fc.RFIDData = fc.MyBTLF.WriteTagData(fc.TagType, NumBlock.Value.ToString(), txtData.Text);
                    if ((fc.RFIDData == "- 1"))
                    {
                        InfoAdd("Write Error");
                    }
                    if ((fc.RFIDData == "- 2"))
                    {
                        InfoAdd("Write Error");
                    }
                    if ((fc.RFIDData == "- 3"))
                    {
                        InfoAdd("Block length Error");
                    }
                    if (fc.RFIDData.IndexOf("+") >= 0)  // ERROR: Unknown binary operator Like
                    {
                        InfoAdd("Write OK");
                    }
                    if (fc.RFIDData.IndexOf("Error") >= 0)
                    {
                        InfoAdd(GetErrorText(fc.RFIDData.Trim()));
                        InfoAdd("Write Error");
                    }
                }
            }
            finally
            {
                cbReadWriteBox.Enabled = true;
            }
        }

        private string GetErrorText(string Err)
        {
            string result = Err;
             switch (Err) {
                 case "Error: 4":
                     result = "ERROR LOST HOST"; //– the link with the host was lost. The RTS signal went inactive. This is not always an error. 
                     break;
                 case "Error: 5":
                     result = "ERROR ONLINE"; //– the link with the host was (re)established. The RTS signal became active. This is not always an error. 
                     break;
                 case "Error: 6": 
                     result = "ERROR NUMBER EXPECTED"; //– A number was expected at this place. This is a speciﬁc kind of a syntax error. 
                     break;
                 case "Error: 7": 
                     result = "ERROR STACK OVERFLOW"; // – The execution stack was overﬂown. Too many nesting levels in function calls and/or loops were attemted. 
                     break;
                 case "Error: 8": 
                     result = "ERROR NOT IMPLEMENTED"; // – The command invoked is deﬁned, but not implemented in the current ﬁrmware version. 
                     break;
                 case "Error: 9": 
                     result = "ERROR SYNTAX"; // – A syntax error occured. Its nature is not speciﬁed. It should be deduced out of the context of its occurence. 
                     break;
                 case "Error: 10": 
                    result = "ERROR SWALLOW"; // – A speciﬁc syntactic element was expected (brace, parenthesis and so on), but something else was encountered 
                    break;
                case "Error: 12": 
                    result = "ERROR MISPLACED STATEMENT"; // – A statement was encountered were it was not expected. 
                    break;
                case "Error: 14": 
                    result = "ERROR TERM SYNTAX"; // – Syntax error in an expression. 
                    break;
                case "Error: 15": 
                    result = "ERROR TERM SYNTAX2"; // – Syntax error in an expression. 
                    break;
                case "Error: 16": 
                    result = "ERROR AFTER NOISE"; // – Some characters were received after the end of a valid command and before the concluding CR character. 
                    break;
                case "Error: 17": 
                    result = "ERROR INVALID ARGUMENT"; // – An system command argument has an illegal value. Please consult the commands description for legal values. 
                    break;
                case "Error: 18": 
                    result = "ERROR NO DATA"; //– Data which is supposed to be present for the current command is missing completely or partially. 
                    break;
                case "Error: 21": 
                    result = "ERROR BAD HEX"; // – An illegal character followed a 0x hex number preﬁx. 
                    break;
                case "Error: 22": 
                    result = "ERROR BAD CHAR"; // – An C token starts with an illegal character. 
                    break;
                case "Error: 23": 
                    result = "ERROR UPPER CASE"; // – No C token can contain an upper case letter. 
                    break;
                case "Error: 32": 
                    result = "ERROR DATASTACK OVERFLOW"; // – Too many items were pushed on the data stack.
                    break;
                case "Error: 33": 
                    result = "ERROR DATASTACK UNDERFLOW"; // – The data stack doesn’t contain enough items for the current word to complete. 
                    break;
                case "Error: 34": 
                    result = "ERROR ONLY COMPILATION"; // – A word is only allowed in compi- lation mode. For example: IF, THEN, BEGIN... 
                    break;
                case "Error: 35":
                    result = "ERROR INVALID FUNCNAME"; // – The user function name (or word) does’t belong to the supported set of names. 
                    break;
                case "Error: 36": 
                    result = "ERROR UNDEFINED FUNCTION"; // – An undeﬁned user function (or word) was invoked or listed. 
                    break;
                case "Error: 37": 
                    result = "ERROR UNDEFINED MAIN"; // – The autorun function (or word) is not deﬁned. 
                    break;
                case "Error: 38": 
                    result = "ERROR ALREADY DEFINED"; // – An attempt was made to redeﬁne an already deﬁned user function (or word). 
                    break;
                case "Error: 39": 
                    result = "ERROR OUT OF MEMORY"; // – The is no more memory available for user functions (or words). 
                    break;
                case "Error: 40": 
                    result = "ERROR PROG COMMAND"; // – This is a syntax error. No such programming command exists. 
                    break;
                case "Error: 42": 
                    result = "ERROR INCOMPLETE DEFINITION"; // – An incomplete word deﬁ- nition was entered. Check the user word deﬁnition. 
                    break;
                case "Error: 54": 
                    result = "ERROR NO COMMAND"; // – no such command is available in the ﬁrmware. 
                    break;
                case "Error: 61": 
                    result = "ERROR NO STRING"; // – a string is expected in the string output function. 
                    break;
                case "Error: 63": 
                    result = "ERROR ANCIENT HARDWARE"; // – the hardware of the reader doesn’t support this function. 
                    break;
                case "Error: 73": 
                    result = "ERROR OEM COMMAND"; // – the OEM module was locked. OEM commands are no longer available. 
                    break;
                case "Error: 76": 
                    result = "ERROR BITLENGHT NOT SUPPORTED"; // – the speciﬁed SPB (sam- ples per baud) value is not supported 
                    break;
                case "Error: 77": 
                    result = "ERROR MODULATION NOT SUPPORTED"; // – the type of modulation speciﬁed is not supported by the current ﬁrmware. 
                    break;
                case "Error: 78":
                    result = "ERROR DECODING NOT SUPPORTED"; // – the type of bit decoding speciﬁed is not supported by the current ﬁrmware.
                    break;
             }
           return result;
        }

        private void ExitItem_Click(Object sender, EventArgs e)
        {
            if (cbConti.Checked)
            {
                cbConti.Checked = false;
                InfoAdd("Stop Continues Read");
            }
            if (MessageBox.Show("Close Form ?",this.Text,MessageBoxButtons.YesNo,MessageBoxIcon.Question,MessageBoxDefaultButton.Button1) == DialogResult.Yes)         
            {
                Close();
            }
        }


        private void cbReadWriteBox_SelectedIndexChanged(Object sender, EventArgs e)
        {
            btReadWriteData.Text = cbReadWriteBox.Text;
        }


        private void frmLF_KeyUp(Object sender, System.Windows.Forms.KeyEventArgs e)
        {
        }

        private void frmLF_Load(Object sender, EventArgs e)
        {
            cbReadWriteBox.SelectedIndex = 0;
        }

        private void TitanPassItem_Click(Object sender, EventArgs e)
        {
            frmPassword frmPasswordDlg = new frmPassword(this.fc);
            frmPasswordDlg.txtPassword1.Text = fc.MyBTLF.TitanPassword;
            frmPasswordDlg.txtPassword2.Text = fc.MyBTLF.TitanPassword;
            frmPasswordDlg.lbTagInfo.Text = fc.TagName;
            frmPasswordDlg.ShowDialog();
            fc.MyBTLF.TitanPassword = frmPasswordDlg.txtPassword1.Text;
            if ((frmPasswordDlg != null))
            {
                frmPasswordDlg.Dispose();
                frmPasswordDlg = null;
            }
        }

        private void Hitag2Item_Click(Object sender, EventArgs e)
        {
            frmPassword frmPasswordDlg = new frmPassword(this.fc);
            frmPasswordDlg.txtPassword1.Text = fc.MyBTLF.Hitag2Password;
            frmPasswordDlg.txtPassword2.Text = fc.MyBTLF.Hitag2Password;
            frmPasswordDlg.lbTagInfo.Text = fc.TagName;
            frmPasswordDlg.ShowDialog();
            fc.MyBTLF.Hitag2Password = frmPasswordDlg.txtPassword1.Text;
            if ((frmPasswordDlg != null))
            {
                frmPasswordDlg.Dispose();
                frmPasswordDlg = null;
            }
        }

        private void ClearItem_Click(Object sender, EventArgs e)
        {
            ListBox1.Items.Clear();
        }

        private void EventItem_Click(Object sender, EventArgs e)
        {
            EventItem.Checked = !EventItem.Checked;
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            if (cbConti.Checked)
            {
                cbConti.Checked = false;
            }
            this.Hide();
            fc.Hide();
            fc.Tray1.InitialDuration = 0;
            fc.Tray1.Visible = true;
        }

        private void ChangeLFItem_Click(object sender, EventArgs e)
        {
            ListBox1.Items.Clear();
            InfoAdd("Close Reader"); 
            fc.CloseReader(0);
            MessageBox.Show("Please change the LF-Reader." + '\r' + "Then they press OK.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
            fc.PlaySound();
            fc.Reader_Typ = 1;
            InfoAdd("Check LF-Reader"); 
            fc.CheckReaderOnBoard();
            if (fc.MyBTLF.Active)
            {
                InfoAdd("LF-Reader found");
                InfoAdd("Check Version"); 
            }
            else
            {
                InfoAdd("ERROR: No LF-Reader found");
            }
            btGetVersion_Click(null, null);
        }
     
    }
}